Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Telerik.WinControls.UI
Imports Telerik.WinControls.Primitives
Imports Telerik.WinControls.RadControlSpy

Namespace _451319
    Partial Public Class Form1
        Inherits Form
        Public Sub New()
            InitializeComponent()

            radTreeView1.TreeViewElement.ViewElement.ElementProvider.ClearCache()
            AddHandler radTreeView1.CreateNodeElement, AddressOf radTreeView1_CreateNodeElement
            AddHandler radTreeView1.NodeFormatting, AddressOf radTreeView1_NodeFormatting
        End Sub

        Private Sub radTreeView1_NodeFormatting(ByVal sender As Object, ByVal e As TreeNodeFormattingEventArgs)
            Dim element As CustomTreeNodeElement = TryCast(e.NodeElement, CustomTreeNodeElement)
            If Not element Is Nothing Then

                If e.Node.Parent IsNot Nothing Then

                    Dim parentNode As RadTreeNode = DirectCast(e.Node.Parent, RadTreeNode)
                    Dim currentNode As RadTreeNode = e.Node
                    Dim number As String = ""

                    While parentNode IsNot Nothing
                        Dim numberinLevel As Integer = parentNode.Nodes.IndexOf(currentNode) + 1

                        If (String.IsNullOrEmpty(number)) Then
                            number = numberinLevel
                        Else
                            number = number.Insert(0, ".")
                            number = number.Insert(0, numberinLevel)
                        End If

                        parentNode = parentNode.Parent
                        currentNode = currentNode.Parent

                    End While
                    number = number.Insert(0, ".")
                    number = number.Insert(0, currentNode.Index + 1)
                    element.NumberElement.Text = number
                Else
                    element.NumberElement.Text = e.Node.Index + 1
                End If


            End If
        End Sub

        Private Sub radTreeView1_CreateNodeElement(ByVal sender As Object, ByVal e As CreateTreeNodeElementEventArgs)
            e.NodeElement = New CustomTreeNodeElement()
        End Sub
    End Class

    Friend Class CustomTreeNodeElement
        Inherits TreeNodeElement
        Private numberElement_Renamed As LightVisualElement

        Protected Overrides Sub CreateChildElements()
            MyBase.CreateChildElements()

            numberElement_Renamed = New LightVisualElement()
            numberElement_Renamed.StretchHorizontally = False

            Me.Children.Insert(3, numberElement_Renamed)
        End Sub

        Protected Overrides Function ArrangeOverride(finalSize As System.Drawing.SizeF) As System.Drawing.SizeF
            Return MyBase.ArrangeOverride(finalSize)
        End Function

        Public ReadOnly Property NumberElement() As LightVisualElement
            Get
                Return Me.numberElement_Renamed
            End Get
        End Property

        Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
            Get
                Return GetType(TreeNodeElement)
            End Get
        End Property
    End Class
End Namespace
